unit Forms.Client.Main;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls,
  Sparkle.Utils,
  Sphinx.WebLogin, WEBLib.Buttons, Data.DB, WEBLib.DB,
  WEBLib.Grids, WEBLib.DBCtrls,
  WEBLib.ExtCtrls, XData.Web.Connection, XData.Web.JsonDataset,
  XData.Web.Dataset;

type
  TForm1 = class(TWebForm)
    WebMemo1: TWebMemo;
    SphinxWebLogin1: TSphinxWebLogin;
    WebToolBar1: TWebToolBar;
    WebLabel1: TWebLabel;
    webDBResGrid: TWebDBResponsiveGrid;
    webDSMusil: TWebDataSource;
    WebPanel1: TWebPanel;
    btCheckLogin: TWebButton;
    btLogout: TWebButton;
    btLogin: TWebButton;
    XDataWebConnection: TXDataWebConnection;
    XDataWebDataSet1: TXDataWebDataSet;
    procedure btLoginClick(Sender: TObject);
    procedure btLogoutClick(Sender: TObject);
    procedure btCheckLoginClick(Sender: TObject);
    procedure SphinxWebLogin1UserLoggedIn(Args: TUserLoggedInArgs);
  private
    procedure Log(const Msg: string);
    procedure LogUserInfo(Info: TAuthResult);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btCheckLoginClick(Sender: TObject);
begin
  if SphinxWebLogin1.IsLoggedIn then
  begin
    Log('User already logged in.');
    LogUserInfo(SphinxWebLogin1.AuthResult);
  end
  else
    Log('User is not logged in.');
end;

procedure TForm1.btLoginClick(Sender: TObject);
begin
  SphinxWebLogin1.Login;
end;

procedure TForm1.btLogoutClick(Sender: TObject);
begin
  SphinxWebLogin1.Logout;
  Log('User logged out.');
  webLabel1.Caption:='abgemeldet.';
  btLogin.Enabled:=true;
end;

procedure TForm1.Log(const Msg: string);
begin
  WebMemo1.Lines.Add(Msg);
end;

procedure TForm1.LogUserInfo(Info: TAuthResult);
begin
  Log('==========');
  if Info.Profile <> nil then
    Log('Email: ' + Info.Profile.Email)
  else
    Log('No email information.');
  Log('Scope: ' + Info.Scope);
  Log('Token type: ' + Info.TokenType);
  Log('Expiration: ' + DateTimeToStr(Info.Expiration));
  Log('Is expired: ' + BoolToStr(Info.IsExpired, True));
  Log('Route at the time of login: ' + Info.AppState);
  Log('Id token: ' + Info.IdToken);
  Log('Access token: ' + Info.AccessToken);
  Log('==========');
end;

procedure TForm1.SphinxWebLogin1UserLoggedIn(Args: TUserLoggedInArgs);
begin
  Log('User logged in successfully.');
  btLogin.Enabled:=false;
//  LogUserInfo(Args.LoginResult);
  webLabel1.Caption:= args.loginResult.Profile.Email;
end;

end.
