unit Forms.Main;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls,
  Sparkle.Utils,
  Sphinx.WebLogin;

type
  TForm1 = class(TWebForm)
    WebMemo1: TWebMemo;
    btLogin: TWebButton;
    btLogout: TWebButton;
    btCheckLogin: TWebButton;
    SphinxWebLogin: TSphinxWebLogin;
    procedure btLoginClick(Sender: TObject);
    procedure btLogoutClick(Sender: TObject);
    procedure btCheckLoginClick(Sender: TObject);
    procedure SphinxWebLoginUserLoggedIn(Args: TUserLoggedInArgs);
  private
    procedure Log(const Msg: string);
    procedure LogUserInfo(Info: TAuthResult);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btCheckLoginClick(Sender: TObject);
begin
  if SphinxWebLogin.IsLoggedIn then
  begin
    Log('User already logged in.');
    LogUserInfo(SphinxWebLogin.AuthResult);
  end
  else
    Log('User is not logged in.');
end;

procedure TForm1.btLoginClick(Sender: TObject);
begin
  SphinxWebLogin.Authority:='http://178.254.40.246:2001/app/sphinx';
  SphinxWebLogin.RedirectUri:='http://178.254.40.246:2001/app/webclient/';
  SphinxWebLogin.Scope:='openid email';
  SphinxWebLogin.Login;
end;

procedure TForm1.btLogoutClick(Sender: TObject);
begin
  SphinxWebLogin.Logout;
  Log('User logged out.');
end;

procedure TForm1.Log(const Msg: string);
begin
  WebMemo1.Lines.Add(Msg);
end;

procedure TForm1.LogUserInfo(Info: TAuthResult);
begin
  Log('==========');
  if Info.Profile <> nil then
    Log('Email: ' + Info.Profile.Email)
  else
    Log('No email information.');
  Log('Scope: ' + Info.Scope);
  Log('Token type: ' + Info.TokenType);
  Log('Expiration: ' + DateTimeToStr(Info.Expiration));
  Log('Is expired: ' + BoolToStr(Info.IsExpired, True));
  Log('Route at the time of login: ' + Info.AppState);
  Log('Id token: ' + Info.IdToken);
  Log('Access token: ' + Info.AccessToken);
  Log('==========');
end;

procedure TForm1.SphinxWebLoginUserLoggedIn(Args: TUserLoggedInArgs);
begin
  Log('User logged in successfully.');
  LogUserInfo(Args.LoginResult);
end;

end.
